"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var radio_common_1 = require("./radio.common");
__export(require("./radio.common"));
var RadioGroupCheckedChangeListener;
var RadioButtonCheckedChangeListener;
function initializeRadioGroupCheckedChangeListener() {
    if (RadioGroupCheckedChangeListener) {
        return;
    }
    var RadioGroupCheckedChangeListenerImpl = (function (_super) {
        __extends(RadioGroupCheckedChangeListenerImpl, _super);
        function RadioGroupCheckedChangeListenerImpl(owner) {
            var _this = _super.call(this) || this;
            _this.owner = owner;
            return global.__native(_this);
        }
        RadioGroupCheckedChangeListenerImpl.prototype.getCheckedButton = function (owner, checkedId) {
            if (checkedId != -1) {
                var radioButton = owner.android.findViewById(checkedId);
                return radioButton.owner;
            }
            return null;
        };
        RadioGroupCheckedChangeListenerImpl.prototype.onCheckedChanged = function (group, checkedId) {
            var owner = group.owner;
            if (owner) {
                radio_common_1.checkedButtonProperty.nativeValueChange(owner, checkedId);
                owner.notify({
                    eventName: "checkedChanged",
                    object: owner,
                    button: this.getCheckedButton(owner, checkedId)
                });
            }
        };
        return RadioGroupCheckedChangeListenerImpl;
    }(java.lang.Object));
    RadioGroupCheckedChangeListenerImpl = __decorate([
        Interfaces([android.widget.RadioGroup.OnCheckedChangeListener]),
        __metadata("design:paramtypes", [RadioGroup])
    ], RadioGroupCheckedChangeListenerImpl);
    RadioGroupCheckedChangeListener = RadioGroupCheckedChangeListenerImpl;
}
function initializeRadioButtonCheckedChangeListener() {
    if (RadioButtonCheckedChangeListener) {
        return;
    }
    var RadioButtonCheckedChangeListenerImpl = (function (_super) {
        __extends(RadioButtonCheckedChangeListenerImpl, _super);
        function RadioButtonCheckedChangeListenerImpl(owner) {
            var _this = _super.call(this) || this;
            _this.owner = owner;
            return global.__native(_this);
        }
        RadioButtonCheckedChangeListenerImpl.prototype.onCheckedChanged = function (group, isChecked) {
            var owner = group.owner;
            if (owner) {
                radio_common_1.checkedProperty.nativeValueChange(owner, isChecked);
            }
        };
        return RadioButtonCheckedChangeListenerImpl;
    }(java.lang.Object));
    RadioButtonCheckedChangeListenerImpl = __decorate([
        Interfaces([android.widget.CompoundButton.OnCheckedChangeListener]),
        __metadata("design:paramtypes", [RadioButton])
    ], RadioButtonCheckedChangeListenerImpl);
    RadioButtonCheckedChangeListener = RadioButtonCheckedChangeListenerImpl;
}
var clickListener;
function initializeClickListener() {
    if (clickListener) {
        return;
    }
    var ClickListener = (function (_super) {
        __extends(ClickListener, _super);
        function ClickListener() {
            var _this = _super.call(this) || this;
            return global.__native(_this);
        }
        ClickListener.prototype.onClick = function (v) {
            var owner = v.owner;
            if (owner) {
            }
        };
        return ClickListener;
    }(java.lang.Object));
    ClickListener = __decorate([
        Interfaces([android.view.View.OnClickListener]),
        __metadata("design:paramtypes", [])
    ], ClickListener);
    clickListener = new ClickListener();
}
var RadioButton = (function (_super) {
    __extends(RadioButton, _super);
    function RadioButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RadioButton.prototype.createNativeView = function () {
        initializeClickListener();
        initializeRadioButtonCheckedChangeListener();
        var button = new android.widget.RadioButton(this._context);
        var checkedChangeListener = new RadioButtonCheckedChangeListener(this);
        button.setOnClickListener(clickListener);
        button.setOnCheckedChangeListener(checkedChangeListener);
        button.checkedChangeListener = checkedChangeListener;
        return button;
    };
    RadioButton.prototype.initNativeView = function () {
        this.nativeView.owner = this;
        this.nativeView.checkedChangeListener.owner = this;
        _super.prototype.initNativeView.call(this);
    };
    RadioButton.prototype.disposeNativeView = function () {
        this.nativeView.owner = null;
        this.nativeView.checkedChangeListener.owner = null;
        _super.prototype.disposeNativeView.call(this);
    };
    RadioButton.prototype[radio_common_1.tintProperty.setNative] = function (value) {
        var color = android.graphics.Color.parseColor(value);
        this.nativeView.setButtonTintList(android.content.res.ColorStateList.valueOf(color));
    };
    RadioButton.prototype[radio_common_1.checkedProperty.setNative] = function (isChecked) {
        return this.nativeView.setChecked(isChecked);
    };
    return RadioButton;
}(radio_common_1.RadioButtonBase));
exports.RadioButton = RadioButton;
var RadioGroup = (function (_super) {
    __extends(RadioGroup, _super);
    function RadioGroup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RadioGroup.prototype.createNativeView = function () {
        var view = new android.widget.RadioGroup(this._context);
        initializeRadioGroupCheckedChangeListener();
        var checkedChangeListener = new RadioGroupCheckedChangeListener(this);
        view.setOnCheckedChangeListener(checkedChangeListener);
        view.checkedChangeListener = checkedChangeListener;
        return view;
    };
    RadioGroup.prototype.initNativeView = function () {
        this.nativeView.owner = this;
        this.nativeView.checkedChangeListener.owner = this;
        _super.prototype.initNativeView.call(this);
    };
    RadioGroup.prototype.disposeNativeView = function () {
        this.nativeView.owner = null;
        this.nativeView.checkedChangeListener.owner = null;
        _super.prototype.disposeNativeView.call(this);
    };
    return RadioGroup;
}(radio_common_1.RadioGroupBase));
exports.RadioGroup = RadioGroup;
//# sourceMappingURL=radio.android.js.map