import { TextBase, Property, CssProperty, Style, Color, FormattedString, EventData  } from "tns-core-modules/ui/text-base";
import { View } from "tns-core-modules/ui/core/view";

export class RadioButton extends TextBase {
    tint: string;
    checked: boolean;
}

export const tintProperty: Property<RadioButton, string>;
export const checkedProperty: Property<RadioButton, boolean>;

export class RadioGroup extends View {

    static checkedChangedEvent: string; 

    checkedButton: number;

    on(eventNames: string, callback: (data: EventData) => void, thisArg?: any);
    
    on(event: "checkedChanged", callback: (args: EventData) => void, thisArg?: any);
}

export const checkedButtonProperty: Property<RadioGroup, number>;